/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Russell Boykin       - initial API and implementation
 *     Alberto Giammaria    - initial API and implementation
 *     Chris Peters         - initial API and implementation
 *     Gianluca Bernardini  - initial API and implementation
 *	   Sam Padgett          - initial API and implementation
 *     Michael Fiedler      - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *     Matthieu Helleboid   - Support for multiple Service Providers.
 *     Anass Radouani       - Support for multiple Service Providers.
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.adaptors.basicexample.resources;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.text.SimpleDateFormat;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import java.util.Iterator;
import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import javax.ws.rs.core.UriBuilder;

import org.eclipse.lyo.oslc4j.core.annotation.OslcAllowedValue;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDescription;
import org.eclipse.lyo.oslc4j.core.annotation.OslcMemberProperty;
import org.eclipse.lyo.oslc4j.core.annotation.OslcName;
import org.eclipse.lyo.oslc4j.core.annotation.OslcNamespace;
import org.eclipse.lyo.oslc4j.core.annotation.OslcOccurs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcPropertyDefinition;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRange;
import org.eclipse.lyo.oslc4j.core.annotation.OslcReadOnly;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRepresentation;
import org.eclipse.lyo.oslc4j.core.annotation.OslcResourceShape;
import org.eclipse.lyo.oslc4j.core.annotation.OslcTitle;
import org.eclipse.lyo.oslc4j.core.annotation.OslcValueType;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.Occurs;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.Representation;
import org.eclipse.lyo.oslc4j.core.model.ValueType;

import se.kth.md.adaptors.basicexample.servlet.ServletListener;
import se.kth.md.adaptors.basicexample.BasicAdaptorConstants;
import se.kth.md.adaptors.basicexample.resources.Person;
import se.kth.md.adaptors.basicexample.resources.Person;

// Start of user code imports
// End of user code

// Start of user code preClassCode
// End of user code

// Start of user code classAnnotations
// End of user code
@OslcNamespace(BasicAdaptorConstants.EXTENDED_REQUIRMENT_MANAGEMENT_NAMSPACE)
@OslcName(BasicAdaptorConstants.EXTENDEDREQUIREMENT)
@OslcResourceShape(title = "ExtendedRequirement Resource Shape", describes = BasicAdaptorConstants.TYPE_EXTENDEDREQUIREMENT)
public class ExtendedRequirement
    extends Requirement
    implements IExtendedRequirement
{
    // Start of user code attributeAnnotation:extendedReqProp
    // End of user code
    private HashSet<String> extendedReqProp = new HashSet<String>();
    
    // Start of user code classAttributes
    // End of user code
    // Start of user code classMethods
    // End of user code
    public ExtendedRequirement()
           throws URISyntaxException
    {
        super();
    
        // Start of user code constructor1
        // End of user code
    }
    
    public ExtendedRequirement(final URI about)
           throws URISyntaxException
    {
        super(about);
    
        // Start of user code constructor2
        // End of user code
    }
    
    public ExtendedRequirement(final String serviceProviderId, final String resourceId)
           throws URISyntaxException
    {
        this (constructURI(serviceProviderId, resourceId));
        // Start of user code constructor3
        // End of user code
    }
    
    public static URI constructURI(final String serviceProviderId, final String resourceId)
    {
        String basePath = ServletListener.getServicesBase();
        Map<String, Object> pathParameters = new HashMap<String, Object>();
        pathParameters.put("serviceProviderId", serviceProviderId);
        pathParameters.put("resourceId", resourceId);
        String instanceURI = "req-services/{serviceProviderId}/extendedRequirements/{resourceId}";
    
        final UriBuilder builder = UriBuilder.fromUri(basePath);
        return builder.path(instanceURI).buildFromMap(pathParameters);
    }
    
    public static Link constructLink(final String serviceProviderId, final String resourceId , final String label)
    {
        return new Link(constructURI(serviceProviderId, resourceId), label);
    }
    
    public static Link constructLink(final String serviceProviderId, final String resourceId)
    {
        return new Link(constructURI(serviceProviderId, resourceId));
    }
    
    public String toString()
    {
        return toString(false);
    }
    
    public String toString(boolean asLocalResource)
    {
        String result = "";
        // Start of user code toString_init
        // End of user code
    
        if (asLocalResource) {
            result = result + "{a Local ExtendedRequirement Resource} - update ExtendedRequirement.toString() to present resource as desired.";
            // Start of user code toString_bodyForLocalResource
            // End of user code
        }
        else {
            result = getAbout().toString();
        }
    
        // Start of user code toString_finalize
        // End of user code
    
        return result;
    }
    
    public String toHtml()
    {
        return toHtml(false);
    }
    
    public String toHtml(boolean asLocalResource)
    {
        String result = "";
        // Start of user code toHtml_init
        // End of user code
    
        if (asLocalResource) {
            result = toString(true);
            // Start of user code toHtml_bodyForLocalResource
            // End of user code
        }
        else {
            result = "<a href=\"" + getAbout() + "\">" + toString() + "</a>";
        }
    
        // Start of user code toHtml_finalize
        // End of user code
    
        return result;
    }
    
    public void addExtendedReqProp(final String extendedReqProp)
    {
        this.extendedReqProp.add(extendedReqProp);
    }
    
    
    // Start of user code getterAnnotation:extendedReqProp
    // End of user code
    @OslcName("extendedReqProp")
    @OslcPropertyDefinition(BasicAdaptorConstants.EXTENDED_REQUIRMENT_MANAGEMENT_NAMSPACE + "extendedReqProp")
    @OslcOccurs(Occurs.ZeroOrMany)
    @OslcValueType(ValueType.String)
    @OslcReadOnly(false)
    public HashSet<String> getExtendedReqProp()
    {
        // Start of user code getterInit:extendedReqProp
        // End of user code
        return extendedReqProp;
    }
    
    
    // Start of user code setterAnnotation:extendedReqProp
    // End of user code
    public void setExtendedReqProp(final HashSet<String> extendedReqProp )
    {
        // Start of user code setterInit:extendedReqProp
        // End of user code
        this.extendedReqProp.clear();
        if (extendedReqProp != null)
        {
            this.extendedReqProp.addAll(extendedReqProp);
        }
    
        // Start of user code setterFinalize:extendedReqProp
        // End of user code
    }
    
    
    static public String extendedReqPropToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:extendedReqPropToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"ExtendedReqProp\">ExtendedReqProp: </LABEL>";
    
        // Start of user code "Mid:extendedReqPropToHtmlForCreation(...)"
        // End of user code
    
    	s= s + "<input name=\"extendedReqProp\" type=\"text\" style=\"width: 400px\" id=\"extendedReqProp\" >";
        // Start of user code "Finalize:extendedReqPropToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    
    public String extendedReqPropToHtml()
    {
        String s = "";
    
        // Start of user code extendedReqProptoHtml_init
        // End of user code
    
        s = s + "<label for=\"ExtendedReqProp\"><strong>ExtendedReqProp</strong>: &nbsp;</LABEL>";
    
        // Start of user code extendedReqProptoHtml_mid
        // End of user code
    
        try {
            s = s + "<ul>";
            Iterator<String> itr = extendedReqProp.iterator();
            while(itr.hasNext()) {
                s = s + "<li>";
                s= s + itr.next().toString();
                s = s + "</li>";
            }
            s = s + "</ul>";
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code extendedReqProptoHtml_finalize
        // End of user code
    
        return s;
    }
    
    
}
